package	jp.co.sds_corp.fixconnect.message;

import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;
import java.util.Vector;

public class Component
{
	Field	numField;
	Vector<Node>	vecNode = new Vector<Node>();

	public Component( Field numField ) {
		this.numField = numField;
	}

	public Node addNode() {
		Node node = new Node();
		vecNode.add( node );
		return node;
	}

	public void getBytes( ByteArrayOutputStream bos, TagDictionary dict )
	{
		PrintWriter pw = new PrintWriter( bos );
		Integer tag = numField.getTag().getTagId();
		String value = numField.getValue();
		pw.print( tag + "=" + value );
		pw.flush();
		bos.write( FIXMessage.SOH );

		for ( int i = 0; i < vecNode.size(); i++ ) {
			Node node = vecNode.get( i );
			node.getBytes( bos, dict );
		}
	}

	public String toString() {
		String ret = "";
		if ( numField != null ) {
			ret += "No:" + numField.toString();
		}
		for ( int i = 0; i < vecNode.size(); i++ ) {
			Node node = vecNode.get( i );
			ret += node.toString();
		}
		return ret;
	}

}
