package	jp.co.sds_corp.fixconnect.message;

import java.util.HashMap;

import jp.co.sds_corp.util.config.IConfiguration;

public abstract class DictionaryLoader
{
	TagDictionary	allDict = new TagDictionary();
	TagDictionary	headerDict = new TagDictionary();
	TagDictionary	trailerDict = new TagDictionary();
	HashMap<String,TagDictionary> mapDict = new HashMap<String,TagDictionary>();
	HashMap<String,String> mapTypeName = new HashMap<String,String>();

	protected DictionaryLoader() {
	}

	public abstract void init( IConfiguration config ) throws Exception;

	public void addTag( Tag tag ) {
		allDict.addTag( tag );
	}

	public TagDictionary getTagDictionary() {
		return allDict;
	}

	public TagDictionary getHeaderDictionary() {
		return headerDict;
	}

	public TagDictionary getTrailerDictionary() {
		return trailerDict;
	}

	public TagDictionary getMessageDictionary( String msgType ) {
		return mapDict.get( msgType );
	}

	public void putMessageDictionary( String msgType, String name, TagDictionary dict ) {
		mapDict.put( msgType, dict );
		mapTypeName.put( msgType, name );
	}
	public String getMsgTypeName( String msgType ) {
		return mapTypeName.get( msgType );
	}

	public Tag findTagName( String tagName ) throws TagNotFoundException {
		Tag ret = allDict.findTagName( tagName );
		if ( ret == null ) {
			throw( new TagNotFoundException( "name=" + tagName ));
		}
		return ret;
	}
	public Tag findTag( String tagId ) throws TagNotFoundException {
		Integer id = null;
		try {
			id = Integer.valueOf( tagId );
		} catch ( Exception ex ) {
			throw( new TagNotFoundException( "invalid id [" + tagId + "]", ex ));
		}
		Tag ret = findTag( id );
		return ret;
	}
	public Tag findTag( Integer tagId ) throws TagNotFoundException {
		Tag ret = allDict.findTag( tagId );
		if ( ret == null ) {
			throw( new TagNotFoundException( "id=" + tagId ));
		}
		return ret;
	}

}
