package	jp.co.sds_corp.fixconnect.message;

import jp.co.sds_corp.fixconnect.transport.FIXSession;
import jp.co.sds_corp.fixconnect.transport.FIXSocket;

public class MessageReceiveEvent
{
	public MessageReceiveEvent( FIXSocket source, FIXMessage message ) {
		this.source = source;
		this.message = message;
	}

	public String toString() {
		String ret = getClass().getName();
		if ( getSession() != null ) {
			ret += " session=[" + getSession().toString() + "]";
		} else {
			ret += " source=[" + getSource() + "]";
		}
		return ret;
	}

	FIXSession	session;	// FIXセッション情報
	FIXSocket	source;	// メッセージの受信元
	FIXMessage	message;	// 受信メッセージ

	/**
	* FIXセッション情報を設定します。
	* @param	var		設定するデータ
	*/
	public void setSession( FIXSession var ) {
		this.session = var;
	}
	/**
	* FIXセッション情報を取得します。
	* @return	FIXセッション情報
	*/
	public FIXSession getSession() {
		return session;
	}

	/**
	* メッセージの受信元を設定します。
	* @param	var		設定するデータ
	*/
	public void setSource( FIXSocket var ) {
		this.source = var;
	}
	/**
	* メッセージの受信元を取得します。
	* @return	メッセージの受信元
	*/
	public FIXSocket getSource() {
		return source;
	}

	/**
	* 受信メッセージを設定します。
	* @param	var		設定するデータ
	*/
	public void setMessage( FIXMessage var ) {
		this.message = var;
	}
	/**
	* 受信メッセージを取得します。
	* @return	受信メッセージ
	*/
	public FIXMessage getMessage() {
		return message;
	}

}
