package	jp.co.sds_corp.fixconnect.message;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

public class TagDictionary
{
	HashMap<Integer,Tag>	mapTag = new HashMap<Integer,Tag>();
	HashMap<String,Tag>	mapTagName = new HashMap<String,Tag>();
	Vector<Tag>	listTag = new Vector<Tag>();

	public TagDictionary() {
	}

	public void addTag( Tag tag ) {
		mapTag.put( tag.getTagId(), tag );
		mapTagName.put( tag.getName(), tag );
		listTag.add( tag );
	}

	public void addAll( TagDictionary dict ) {
		mapTag.putAll( dict.mapTag );
		mapTagName.putAll( dict.mapTagName );
		listTag.addAll( dict.listTag );
	}

	public List<Tag> listTag() {
		return listTag;
	}

	public Tag findTagName( String tagName ) throws TagNotFoundException {
		Tag ret = mapTagName.get( tagName );
		if ( ret == null ) {
			throw( new TagNotFoundException( "name=" + tagName ));
		}
		return ret;
	}
	public Tag findTag( String tagId ) throws TagNotFoundException {
		Integer id = null;
		try {
			id = Integer.valueOf( tagId );
		} catch ( Exception ex ) {
			throw( new TagNotFoundException( "invalid id [" + tagId + "]", ex ));
		}
		Tag ret = findTag( id );
		return ret;
	}
	public Tag findTag( Integer tagId ) throws TagNotFoundException {
		Tag ret = mapTag.get( tagId );
		if ( ret == null ) {
			throw( new TagNotFoundException( "id=" + tagId ));
		}
		return ret;
	}

}
