package	jp.co.sds_corp.fixconnect.store;

import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.fixconnect.transport.FIXSession;
import jp.co.sds_corp.util.config.IConfigurable;

public interface IMessageStore extends IConfigurable
{
	public void save( FIXSession session, FIXMessage msg ) throws Exception;
	public FIXMessage load( FIXSession session, int seqNo ) throws Exception;

	/**
	* FIX送信通番を設定します。
	* @param	var		設定するデータ
	*/
	public void setSendSeqNum( int var );
	/**
	* FIX送信通番を取得します。
	* @return	FIX送信通番
	*/
	public int getSendSeqNum();

	/**
	* FIX受信通番を設定します。
	* @param	var		設定するデータ
	*/
	public void setRecvSeqNum( int var );
	/**
	* FIX受信通番を取得します。
	* @return	FIX受信通番
	*/
	public int getRecvSeqNum();

	/**
	* debugフラグを設定します。
	* @param	var		設定するデータ
	*/
	public void setDebug( boolean var );
	/**
	* debugフラグを取得します。
	* @return	debugフラグ
	*/
	public boolean isDebug();


}
