package	jp.co.sds_corp.fixconnect.test;

import jp.co.sds_corp.fixconnect.FIXException;
import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.fixconnect.message.IMessageReceiver;
import jp.co.sds_corp.fixconnect.message.MessageReceiveEvent;
import jp.co.sds_corp.fixconnect.transport.ITransportEventListener;
import jp.co.sds_corp.fixconnect.transport.Initiator;
import jp.co.sds_corp.fixconnect.transport.TransportEvent;
import jp.co.sds_corp.util.common.CmnLog;
import jp.co.sds_corp.util.config.DOMConfiguration;

public class TestClient implements IMessageReceiver, ITransportEventListener
{
	Initiator initiator;

	public void init() throws Exception {
		DOMConfiguration config = new DOMConfiguration( "test.xml" );
		initiator = new Initiator();
		initiator.init( config.getChild( "Client" ) );

		initiator.addMessageReceiver( this );
		initiator.addEventListener( this );
	}

	public void onMessage( MessageReceiveEvent ev ) {
		FIXMessage msg = ev.getMessage();
		CmnLog.debug( this, "message: " + msg );
	}

	public void onEvent( TransportEvent ev ) {
		CmnLog.debug( this, "event:" + ev );
	}

	public void onException( FIXException ex ) {
		CmnLog.debug( this, "exception:" + ex, ex );
	}

	public void start() throws Exception {
		FIXMessage msg;
		initiator.start();
		CmnLog.debug( this, "logon: " + initiator.logon() );
		initiator.logout();
	}

	public void start2() throws Exception {
		FIXMessage msg;
		initiator.start();
		msg = new FIXMessage();
		initiator.getSession().putValue( msg, "MsgType", "AAAA" );
		initiator.getSession().putValue( msg, "SenderCompID", "CLIEN=T" );
		initiator.send( msg );
		initiator.logon();
		Thread.sleep( 3000 );
		msg = new FIXMessage();
		initiator.getSession().putValue( msg, "MsgType", "BBBB" );
		initiator.getSession().putValue( msg, "SenderCompID", "CLIENT2" );
		initiator.send( msg );
	}

	public void stop() throws Exception {
		initiator.stop();
	}

	public static void main( String[] args ) {
		try {
			TestClient obj = new TestClient();
			obj.init();
			obj.start();
			obj.stop();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
	}

}

