package	jp.co.sds_corp.fixconnect.test;

import jp.co.sds_corp.fixconnect.FIXException;
import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.fixconnect.message.IMessageReceiver;
import jp.co.sds_corp.fixconnect.message.MessageReceiveEvent;
import jp.co.sds_corp.fixconnect.transport.Acceptor;
import jp.co.sds_corp.fixconnect.transport.ITransportEventListener;
import jp.co.sds_corp.fixconnect.transport.TransportEvent;
import jp.co.sds_corp.util.common.CmnLog;
import jp.co.sds_corp.util.config.DOMConfiguration;

public class TestServer implements IMessageReceiver, ITransportEventListener
{
	Acceptor acc;

	public void init() throws Exception {
		DOMConfiguration config = new DOMConfiguration( "test.xml" );
		acc = new Acceptor();
		acc.init( config.getChild( "Server" ) );

		acc.addMessageReceiver( this );
		acc.addEventListener( this );
	}

	public void onMessage( MessageReceiveEvent ev ) {
		FIXMessage msg = ev.getMessage();
		CmnLog.debug( this, "message: " + msg );
	}

	public void onEvent( TransportEvent ev ) {
		CmnLog.debug( this, "event:" + ev );
	}

	public void onException( FIXException ex ) {
		CmnLog.debug( this, "exception:" + ex, ex );
	}

	public void start() throws Exception {
		acc.start();
	}

	public static void main( String[] args ) {
		try {
			TestServer obj = new TestServer();
			obj.init();
			obj.start();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
	}

}

