package	jp.co.sds_corp.fixconnect.transport;

import java.util.Vector;

import jp.co.sds_corp.fixconnect.FIXException;
import jp.co.sds_corp.fixconnect.message.IMessageReceiver;
import jp.co.sds_corp.fixconnect.message.MessageReceiveEvent;
import jp.co.sds_corp.util.daemon.AbstractService;

public abstract class AbstractTransporter extends AbstractService
	implements IMessageReceiver, ITransportEventListener
{
	private static final long serialVersionUID = 1L;
	Vector<ITransportEventListener>	vecTrn = new Vector<ITransportEventListener>();
	Vector<IMessageReceiver>	vecRcv = new Vector<IMessageReceiver>();

	public void addEventListener( ITransportEventListener l ) {
		vecTrn.add( l );
	}
	public boolean removeEventListener( ITransportEventListener l ) {
		return vecTrn.remove( l );
	}
	public void fireEventOccured( TransportEvent ev ) {
		for ( int i = 0; i < vecTrn.size(); i++ ) {
			ITransportEventListener l = vecTrn.get( i );
			l.onEvent( ev );
		}
	}
	public void fireExceptionOccured( FIXException ex ) {
		for ( int i = 0; i < vecTrn.size(); i++ ) {
			ITransportEventListener l = vecTrn.get( i );
			l.onException( ex );
		}
	}
	public void onEvent( TransportEvent ev ) {
		fireEventOccured( ev );
	}
	public void onException( FIXException ex ) {
		fireExceptionOccured( ex );
	}

	public void addMessageReceiver( IMessageReceiver l ) {
		vecRcv.add( l );
	}
	public boolean removeMessageReceiver( IMessageReceiver l ) {
		return vecRcv.remove( l );
	}
	public void fireMessageReceived( MessageReceiveEvent ev ) {
		for ( int i = 0; i < vecRcv.size(); i++ ) {
			IMessageReceiver l = vecRcv.get( i );
			l.onMessage( ev );
		}
	}
	public void onMessage( MessageReceiveEvent ev ) {
		fireMessageReceived( ev );
	}

}
